	title "Elektronick hrac kostka"

; Seril "Mikrokontrolry PIC", dl 34
; PE 10/2010
;
; Vt pringl
;

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		count			; aktuln poet ten vstupu
		counter			; ta, ze kterho je odvozeno vsledn slo na kostce
		steps			; poet krok, po kterch se m zastavit rotace kostky
		d1				; pomocn promnn pro ekac smyku
		d2				; pomocn promnn pro ekac smyku
	ENDC

; === KONSTATNTY ===
DEF_COUNT	EQU	0x20		; vchoz poet ten vstupu pro count

; === PROGRAM ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
	BCF		STATUS, RP0	; vbr banky 0
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; Piny RA<7:0> jako vstupy
	MOVLW	0x01
	MOVWF	TRISB		; Piny RB<7:1> jako vstupy, RB0 jako vstup

	BCF		STATUS, RP0	; vbr banky 0
	CLRF	counter

; Hlavn smyka programu
LOOP_M
	MOVLW	DEF_COUNT
	MOVWF	count		; count = DEF_COUNT (nahrn vchoz hodnoty)
LOOP1
	CALL	INC_COUNTER
	BTFSC	PORTB, 0	; PORTB<0> = 0?
	GOTO	LOOP_M		;  - ne: skok na LOOP_M
	DECFSZ	count, f	;  - ano: tlatko bylo sepnuto, count = count - 1
	GOTO	LOOP1
LOOP2
	CALL	INC_COUNTER
	BTFSS	PORTB, 0	; PORTB<0> = 1?
	GOTO	LOOP2		;  - ne: skok na LOOP2
						;  - ano: tlatko bylo rozepnuto, pokrauj
	CALL	CHANGE_LED	; aktualizuj vstupn stav
	GOTO	LOOP_M

; Podprogram pro rotaci kostky a zobrazen vstupu
CHANGE_LED
	; nastav poet krok pro rotaci kostky, steps = <8,15>
	MOVF	counter, W		; W = counter
	ANDLW	b'01110000'		; zamaskovn bit (W = counter<6:4>)
	MOVWF	steps
	SWAPF	steps, f		; steps<2:0> = counter<6:4>
	BSF		steps, 3
		
CHANGE_LED1
	MOVF	counter, W		; W = counter
	ANDLW	b'00000111'		; zamaskovn bit (W = counter<2:0>)
	CALL	LOOKUP
	MOVWF	PORTB			; aktualizace vstupu
	CALL	INC_COUNTER
		
	CALL	DELAY
	DECFSZ	steps, f		; steps = steps - 1, vsledek = 0?
	GOTO	CHANGE_LED1		;  - ne: skok na CHANGE_LED1
	RETURN					;  - ano: nvrat

; Podprogram pro inkrementaci vnitnho tae, kter zajiuje, 
; e na poslednch tech bitech promnn 'counter' bude vdy slo od 0 do 5
INC_COUNTER
	INCF	counter, f		; counter = counter + 1
	MOVF	counter, W		; W = counter
	ANDLW	b'00000111'		; zamaskovn bit (W = counter<2:0>)
	SUBLW	.6				; W = 6 - W
	BTFSS	STATUS, Z		; vsledek = 0?
	RETURN					;  - ne: nvrat
	MOVLW	.2				;  - ano: counter = counter + 2
	ADDWF	counter, f		;    bude tedy: counter<2:0> = 000
	RETURN
	
; Datov tabulka vracejc konfiguraci LED pro zobrazen jednotlivch sel na kostce
; uspodn LED:
; L0 L1 L2
;    L3
; L4 L5 L6
LOOKUP
	ADDWF PCL, f
	RETLW b'00010000'		; 1 ... L3
	RETLW b'00101000'		; 2 ... L2, L4
	RETLW b'10010010'		; 3 ... L0, L3, L6
	RETLW b'10101010'		; 4 ... L0, L2, L4, L6
	RETLW b'10111010'		; 5 ... L0, L2, L3, L4, L6
	RETLW b'11101110'		; 6 ... L0, L1, L2, L4, L5, L6

; Podprogram s ekac smykou
DELAY
	MOVLW	0x03
	MOVWF	d2
DELAY1
	DECFSZ	d1, f
	GOTO	DELAY1
	DECFSZ	d2, f
	GOTO	DELAY1
	RETURN

	END