	title "Obsluha klvesnice se zobrazenm na LED displeji"

; Seril "Mikrokontrolry PIC", dl 35
; PE 11/2010
;
; Vt pringl
;
; Popis: Program zobraz na sedmisegmentovm LED displeji
; aktuln stisknutou klvesu na 4x4 maticov klvesnici

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		keycode			; kd klvesy
		row_in			; naten dek z klvesnice			
		colcount		; potadlo sloupc
	ENDC

; === PROGRAM ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
	BCF		STATUS, RP0	; vbr banky 0
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; Piny RA<7:0> jako vstupy
	MOVLW	0xFF
	MOVWF	TRISB		; Piny RB<7:0> jako vstupy
	BCF		OPTION_REG, 7	; Intern pull-up rezistory na portu B aktivn

	BCF		STATUS, RP0	; vbr banky 0
; Hlavn smyka programu
LOOP_M
	CALL	KEYSCAN		; ten klvesnice, kd klvesy se ulo do W
	CALL	DISP_TABLE	; dekdovan segment pro zobrazen na LED displeji ( -> W)
	MOVWF	PORTA		; zobrazen na displeji
	GOTO	LOOP_M

; Podprogram pro scan klvesnice
KEYSCAN
	CLRF	keycode		; keycode = 0
	BSF		STATUS, RP0	; banka 1
	MOVLW	0xEF
	MOVWF	TRISB		; RB4 jako vstup
	BCF		STATUS, RP0	; banka 0
ROWSCAN
	CLRF	PORTB
	MOVF	PORTB, W	; ten aktivovanho dku klvesnice
	MOVWF	row_in		; row_in = PORTB
	MOVLW	.4
	MOVWF	colcount	; colcount = 4
COLSCAN
	RRF		row_in, f
	BTFSS	STATUS, C	; jestlie C = 0, byla stisknuta klvesa
	GOTO	KEY_TABLE	; dekduj klvesu a nvrat
	INCF	keycode, f	; keycode = keycode + 1
	DECFSZ	colcount, f	; colcount = colcount - 1, vsledek = 0?
	GOTO	COLSCAN		;  - ne: vechny sloupce jet nebyly peteny
						;  - ano: aktivuj dal dek
	BSF		STATUS, C	; C = 1
	BSF		STATUS, RP0	; banka 1
	RLF		TRISB, f	; dal dek
	BCF		STATUS, RP0 ; banka 0
	BTFSC	STATUS, C	; C = 0?
	GOTO	ROWSCAN		;  - ne: jet nebyly peteny vechny dky
	RETLW	0x10		; dn klvesa nebyla stisknuta, nvrat (W = 10h)

; Datov tabulka s kdy klves
KEY_TABLE
	MOVF	keycode, W
	ADDWF	PCL, f
	DT 	0x01,0x02,0x03,0x0A,0x04,0x05,0x06,0x0B
	DT	0x07,0x08,0x09,0x0C,0x0E,0x00,0x0F,0x0D

; Datov tabulka dekdujc segmenty pro zobrazen na LED displeji
DISP_TABLE
	ADDWF	PCL, f
	DT	b'10000000',b'11011001',b'01000100',b'01010000'
	DT	b'00011001',b'00010010',b'00000010',b'11011000'
	DT	b'00000000',b'00010000',b'00001000',b'00000011'
	DT	b'10000110',b'01000001',b'00000110',b'00001110'
	DT	b'11011111'
	END