	title "Zobrazen vsledku A/D pevodu pomoc 10 LED"

; Seril "Mikrokontrolry PIC", dl 44
; PE 08/2011
;
; Vt pringl
;
; Popis: Program zobraz vsledek A/D pevodu pomoc 10 LED 
; 

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		d1, d2			; pomocn promnn pro ekac smyku
	ENDC

; === PROGRAM ===
RESET	ORG		0x0000	; zatek programu na adrese 0000h

; Inicializace port
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	MOVLW	b'00000100'	
	MOVWF	ANSEL		; pin RA2/AN2 jako analogov vstup
	MOVWF	TRISA		; pin RA2/AN2 jako vstup
	CLRF	TRISB		; piny RB<7:0> jako vstupy

	BSF		PIE1, ADIE		; Povolen A/D peruen
	BSF		INTCON, PEIE	; Povolen perifernch peruen

	MOVLW	b'10000000'		; 
	MOVWF	ADCON1			; Zarovnn vsl. doprava, VREF+ = VDD, VREF- = VSS

	BCF		STATUS, RP0		; vbr banky 0
	MOVLW	b'11010001'		; RC osciltor, kanl 2 (AN2), zapnut ADC
	MOVWF	ADCON0			; 

; Hlavn smyka programu
MAIN
	BSF		ADCON0, GO		; Sputn A/D pevodu
	SLEEP

	BSF		STATUS, RP0		; Vbr banky 1
	MOVF	ADRESL, W		; Naten osmi nejmn vznamnch bit vsledku
	BCF		STATUS, RP0		; Vbr banky 0
	MOVWF	PORTB			; 
	MOVF	ADRESH, W		; Naten dvou nejvznamnjch bit vsledku
	MOVWF	PORTA
	CALL	DELAY			; Prodleva cca 0,5s
	GOTO	MAIN

; Podprogram ekac smyky (cca 0,5s)
DELAY
	MOVLW	0x05
	MOVWF	d2
DELAY1
	DECFSZ	d1, f
	GOTO	DELAY1
	DECFSZ	d2, f
	GOTO	DELAY1
	RETURN

	END