	title "Seznmen s kompartorem C2"

; Seril "Mikrokontrolry PIC", dl 46
; PE 10/2011
;
; Vt pringl
;
; Popis: Je-li na vstupu R2/AN2 napt vt ne na vstupu RA1/AN1, 
;		 rozsvt se LED pipojen k vvodu RB0.
; 

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === PROGRAM ===
RESET	ORG		0x0000	; zatek programu na adrese 0000h

; Inicializace port
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	MOVLW	b'00000110'	
	MOVWF	ANSEL		; piny RA1/AN1 a RA2/AN2 jako analogov vstupy
	MOVWF	TRISA		; piny RA1/AN1 a RA2/AN2 jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Konfigurace kompartor
	MOVLW	b'00000101'
			;      +++------- CM2:CM0
			;     +---------- CIS
			;    +----------- C1INV
			;   +------------ C2INV
			;  +------------- C1OUT
			; +-------------- C2OUT
	MOVWF	CMCON			; kompartor C1 vypnut, vstupy C2: Vin-: RA1/AN1, Vin+: RA2/AN2

; Hlavn smyka programu
MAIN
	BSF		STATUS, RP0		; vbr banky 1
	BTFSS	CMCON, C2OUT	; C2OUT = 1?
	GOTO	MAIN0			;  - ne: skok na MAIN0
	BCF		STATUS, RP0		;  - ano: vbr banky 0
	BSF		PORTB, 0		; RB0 = H
	GOTO	MAIN

MAIN0
	BCF		STATUS, RP0		; vbr banky 0
	BCF		PORTB, 0		; RB0 = L

	GOTO	MAIN

	END