	title "Prce s kompartory, reimem SLEEP a peruenm"

; Seril "Mikrokontrolry PIC", dl 46
; PE 10/2011
;
; Vt pringl
;
; Popis: Pekro-li napt na vstupu RA2/AN2 0,25 Vdd
;		 nebo poklesne-li napt na tomto vstupu pod tuto rove,
; 		 rozsvt se na cca 2s LED pipojen k pinu RB0.

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x70
		d1, d2			; pomocn promnn pro ekac smyku
		comp_prev		; informace o pedchoz hodnot bitu C2OUT
		W_temp			; doasn uloen obsahu registru W pi vyvoln peruen
		status_temp		; doasn uloen obsahu registru STATUS pi vyvoln peruen
	ENDC



; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h
	GOTO	INIT

; === OBSLUHA PERUEN ===
ISR		ORG		0x0004		; vektor peruen
; Uloen obsahu registr W a STATUS
	MOVWF	W_temp
	MOVF	STATUS,W		; W -> W_temp
	MOVWF	status_temp		; STATUS -> status_temp

	BSF		STATUS, RP0		; vbr banky 1

	MOVF	CMCON, W
	ANDLW	b'10000000'
	SUBWF	comp_prev, W
	BTFSC	STATUS, Z		; C2OUT (CMCON<7>) = comp_prev<7> ?
	GOTO	ISR_END			;  - ano: peruen nebylo vyvolno zmnou rovn na vstupu C2

	MOVF	CMCON, W		;  - ne: zmnila se rove na vstupu C2
	ANDLW	b'10000000'		; ulo novou hodnotu bitu C2OUT do reg. comp_prev
	MOVWF	comp_prev
	
	BCF		STATUS, RP0		; vbr banky 0
	BSF		PORTB, 0		; RB0 = H

	MOVLW	0x15			; nastaven vchozch hodnot promnnch pro ekac smyku
	MOVWF	d2
	CLRF	d1
	
ISR_END
	BCF		STATUS, RP0		; vbr banky 0
	BCF		PIR2, CMIF		; vynulovn pznaku peruen od kompartor

; Nahrn obsahu registr W a STATUS
	MOVF    status_temp,W	; status_temp -> STATUS
	MOVWF   STATUS
	SWAPF   W_temp,f
	SWAPF   W_temp,W		; W_temp -> W
	RETFIE					; nvrat z peruen


; === PROGRAM ===
INIT
; Inicializace port
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	MOVLW	b'00000100'	
	MOVWF	ANSEL		; piny RA2 jako analogov vstup
	MOVWF	TRISA		; piny RA2 jako vstup
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Konfigurace kompartor
	MOVLW	b'00001010'
	MOVWF	CMCON		; C1: Vin-: RA3/AN3, Vin+: int. ref. napt
						; C2: Vin-: RA2/AN2, Vin+: int. ref. napt

; Konfigurace referennho napt
	MOVLW	b'10000000'
			;     ++++------- CVR3:CVR0
			;   +------------ CVRR
			;  +------------- CVROE
			; +-------------- CVREN
	MOVWF	CVRCON		; ref. nap. zapnuto, vstup nen pipojen k RA2, 
						; rozsah: 0,25 a 0,72 CVrsrc,
						; zvolen napt: 0,25 CVrsrc, tj. cca 0,25 Vdd

; Nastaven peruen
	BSF		PIE2, CMIE		; povolen peruen od kompartor
	BSF		INTCON, PEIE	; povolen perifernch peruen
	BSF		INTCON, GIE		; povolen celho systmu peruen

MAIN
	SLEEP				; pechod do spornho reimu
	NOP
	BCF		STATUS, RP0	; vbr banky 0
	CALL	DELAY		; Voln ekac smyky
	BCF		PORTB, 0	; RB0 = L
	GOTO	MAIN

; Podprogram ekac smyky (cca 2s)
DELAY
	MOVLW	0x15
	MOVWF	d2
DELAY1
	DECFSZ	d1, f
	GOTO	DELAY1
	DECFSZ	d2, f
	GOTO	DELAY1
	RETURN

	END