	title "Men periody s pomoc modulu CCP nastavenho do mdu Capture"

; Seril "Mikrokontrolry PIC", dl 48
; PE 12/2011
;
; Vt pringl
;
; Popis: Program zobraz na jednomstnm sedmisegmentovm displeji LED seln daj (0 a F),
;		 kter je pmo mrn velikosti periody vstupnho obdlnkovho signlu pivdnho
;		 na vstup CCP1.

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
						; Pin CCP1 je RB0
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x70
		t_prev			; pedchoz hodnota registru CCPR1H
		W_temp			; doasn uloen obsahu registru W pi vyvoln peruen
		status_temp		; doasn uloen obsahu registru STATUS pi vyvoln peruen
	ENDC

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h
	GOTO	INIT

; === OBSLUHA PERUEN ===
ISR		ORG		0x0004		; vektor peruen
; Uloen obsahu registr W a STATUS
	MOVWF	W_temp
	MOVF	STATUS,W	; W -> W_temp
	MOVWF	status_temp	; STATUS -> status_temp

	MOVF	t_prev, W
	SUBWF	CCPR1H, W	; W = CCPR1H - t_prev
	
	ANDLW	b'00001111'	; maskovn bit
	CALL	DISP_TABLE	; dekdovan segment pro zobrazen na LED displeji ( -> W)
	MOVWF	PORTA		; zobrazen na displeji

	MOVF	CCPR1H, W
	MOVWF	t_prev		; CCPR1H -> t_prev

	BCF		PIR1, CCP1IF	; vynulovn pznaku peruen od modulu CCP

; Nahrn obsahu registr W a STATUS
	MOVF    status_temp,W	; status_temp -> STATUS
	MOVWF   STATUS
	SWAPF   W_temp,f
	SWAPF   W_temp,W		; W_temp -> W
	RETFIE					; nvrat z peruen


; === PROGRAM ===
INIT
; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	MOVLW	b'00000001'
	MOVWF	TRISB		; piny RB<7:1> jako vstupy, pin RB0 jako vstup

; Nastaven peruen
	BSF		PIE1, CCP1IE	; povolen peruen od modulu CCP
	BSF		INTCON, PEIE	; povolen perifernch peruen
	BSF		INTCON, GIE		; povolen celho systmu peruen	

	BCF		STATUS, RP0	; vbr banky 0

; Nastaven modulu CCP
	MOVLW	b'00000101'	
	MOVWF	CCP1CON		; Md capture, kad nbn hrana

; Nastaven asovae TIMER1
	MOVLW	b'00110001'	
	MOVWF	T1CON		; Peddlicka 1:8, hod. signl odvozen od vnitnho instruknho cyklu (Fosc/4), TIMER1 zapnut

MAIN
	; V hlavn smyce me mikrokontrolr vykonvat dal innost
	GOTO	MAIN

; Datov tabulka dekdujc segmenty pro zobrazen na LED displeji
DISP_TABLE
	ADDWF	PCL, f
	DT	b'10000000',b'11011001',b'01000100',b'01010000'
	DT	b'00011001',b'00010010',b'00000010',b'11011000'
	DT	b'00000000',b'00010000',b'00001000',b'00000011'
	DT	b'10000110',b'01000001',b'00000110',b'00001110'
	DT	b'01011111'

	END