	title "zen jasu LED pomoc pulsn kov modulace"

; Seril "Mikrokontrolry PIC", dl 49
; PE 01/2012
;
; Vt pringl
;
; Popis: Program postupn zvtuje jas LED pipojen k vvodu CCP1.
;        Vyuv k tomu signl s pulsn kovou modulac, kter 
;        je generovn pomoc modulu CCP.

	LIST		p=16F88			; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>	; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
						; Pin CCP1 je RB0
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x70
		d1, d2			; pomocn promnn pro ekac smyku
		pwm1, pwm2		; pomocn promnn pi vpotu stdy PWM signlu
	ENDC

; === KONSTANTY ===
	#DEFINE	DEL	0x3		; velikost prodlevy pi zmn jasu

; === VEKTOR RESETU ===
RESET	ORG		0x0000	; zatek programu na adrese 0000h

; === PROGRAM ===
; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1

	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Nastaven internho osciltoru
	MOVLW	b'00010000'	
	MOVWF	OSCCON		; f = 125kHz

	BCF		STATUS, RP0	; vbr banky 0

; Nastaven modulu CCP
	MOVLW	b'00001100'	
	MOVWF	CCP1CON		; Md PWM

; Nastaven asovae TIMER2
	MOVLW	b'00000100'	
	MOVWF	T2CON		; Peddlicka 1:1, TIMER2 zapnut

MAIN
	CALL	DELAY		; Prodleva
; Oven, zda CCPR1L = FFh, pokud ano, vynuluj CCPR1L a CCPCON<5:4>
	INCF	CCPR1L, W	; W = CCPR1L + 1
	BTFSS	STATUS, Z	; vsledek = 0?
	GOTO	MAIN1		;  - ne: skok na MAIN1
	CLRF	CCPR1L		;  - ano: vynuluj CCPR1L
	MOVLW	b'00001111'
	ANDWF	CCP1CON, f	; a vynuluj CCPCON<5:4>
	GOTO	MAIN

MAIN1
	MOVF	CCP1CON, W	; W = CCP1CON
	ANDLW	b'00110000'	; maskovn bit (zajmaj ns pouze bity CCP1CON<5:4>
	MOVWF	pwm1		; pwm1 = 00_CCP1CON<5:4>_0000
	SWAPF	pwm1, f		; pwm1 = 000000_CCP1CON<5:4>

	MOVF	CCPR1L, W	; W = CCPR1L
	BTFSC	STATUS, Z	; W (CCPR1L) = 0?
	MOVLW	0x01		;  - ano: W = 1
	ANDLW	b'00000011'	; W = 000000_CCPR1L<1:0>
	ADDWF	pwm1, f		; pwm1 = 000000_CCP1CON<5:4> + 000000_CCPR1L<1:0>
	
	MOVF	CCPR1L, W	; W = CCPR1L
	MOVWF	pwm2		; pwm2 = CCPR1L
	RRF		pwm2, f		; rotace pwm2 vpravo -> pwm2
	RRF		pwm2, W		; rotace pwm2 vpravo -> W
	ANDLW	b'00111111'	; W = 00_CCPR1L<7:2> (tj. CCPR1L/4)
	ADDWF	CCPR1L, f	; CCPR1L = CCPR1L + CCPR1L/4

	BTFSS	STATUS, C	; dolo k peteen?
	GOTO	MAIN2		;  - ne: skok na MAIN2
	MOVLW	0xFE
	MOVWF	CCPR1L		;  - ano: CCPR1L = FEh

MAIN2
	BTFSC	pwm1, 2		; dolo k peteen pi stn dvou LSB?
	INCF	CCPR1L, f	;  - ano: CCPR1L = CCPR1L + 1
						;  - ne: pokrauj
	SWAPF	pwm1, W		; W = pwm1<3:0>_pwm1<7:4>
	IORLW	b'00001100'	; nastaven mdu PWM
	MOVWF	CCP1CON		; CCP1CON = 00_pwm1<1:0>_1100
	
	GOTO	MAIN

; Podprogram ekac smyky
DELAY
	MOVLW	DEL
	MOVWF	d2
DELAY1
	DECFSZ	d1, f
	GOTO	DELAY1
	DECFSZ	d2, f
	GOTO	DELAY1
	RETURN

	END