	title "Generovn periodickch peruen v mdu compare"

; Seril "Mikrokontrolry PIC", dl 50
; PE-AR 02/2012
;
; Vt pringl
;
; Popis: 

	LIST		p=16F88				; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
						; Pin CCP1 je RB0
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x70
		W_temp			; doasn uloen obsahu registru W pi vyvoln peruen
		status_temp		; doasn uloen obsahu registru STATUS pi vyvoln peruen
	ENDC

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h
	GOTO	INIT

; === OBSLUHA PERUEN ===
ISR		ORG		0x0004		; vektor peruen
; Uloen obsahu registru W a STATUS
	MOVWF	W_temp
	MOVF	STATUS,W	; W -> W_temp
	MOVWF	status_temp	; STATUS -> status_temp

; Kd periodick aktivity zde...

	BCF		STATUS, RP0		; vbr banky 0
	BCF		PIR1, CCP1IF	; vynulovn pznaku peruen od modulu CCP

; Nahrn obsahu registru W a STATUS
	MOVF    status_temp,W	; status_temp -> STATUS
	MOVWF   STATUS
	SWAPF   W_temp,f
	SWAPF   W_temp,W		; W_temp -> W
	RETFIE					; nvrat z peruen


; === PROGRAM ===
INIT
; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1

	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Nastaven peruen
	BSF		PIE1, CCP1IE	; povolen peruen od modulu CCP
	BSF		INTCON, PEIE	; povolen perifernch peruen

	BCF		STATUS, RP0	; vbr banky 0

; Nastaven modulu CCP
	MOVLW	b'00001011'	
	MOVWF	CCP1CON		; md compare
	MOVLW	0x12
	MOVWF	CCPR1H
	MOVLW	0x34
	MOVWF	CCPR1L

; Nastaven asovae TIMER1
	MOVLW	b'00110001'	
	MOVWF	T1CON		; peddlicka 1:8, hod. signl odvozen od vnitnho instruknho cyklu (Fosc/4), TIMER1 zapnut

; Povolen systmu peruen
	BSF		INTCON, GIE		; povolen celho systmu peruen

MAIN
	; Libovoln kd hlavn smyky zde...
	GOTO MAIN

	END