	title "zen jasu LED pomoc signlu PWM generovanho modulem CCP v mdu compare"

; Seril "Mikrokontrolry PIC", dl 50
; PE-AR 02/2012
;
; Vt pringl
;
; Popis: Program postupn zvtuje jas LED pipojen k vvodu RB0/CCP1.

	LIST		p=16F88				; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
						; Pin CCP1 je RB0
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x70
		d1				; pomocn promnn pro prodlevu pi zmn jasu
		pwmL, pwmH		; pomocn promnn pi vpotu stdy PWM signlu
	ENDC
	
; === KONSTANTY ===
	#DEFINE	DEL	0x6		; velikost prodlevy pi zmn jasu

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h
	GOTO	INIT

; === OBSLUHA PERUEN ===
ISR		ORG		0x0004		; vektor peruen
	CLRF	CCP1CON
	MOVLW	b'00001001'
	MOVWF	CCP1CON			; nastav CCP1=H, rove L pi CCPR1=TMR1

	BCF		PIR1, TMR1IF	; vynulovn pznaku peruen od asovae TIMER1

	DECFSZ	d1, f			; vpoet prodlevy
	RETFIE
	MOVLW	DEL
	MOVWF	d1
	CALL	CHANGE_LED		; zmna jasu LED

	RETFIE					; nvrat z peruen

; === PROGRAM ===
INIT
; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1

	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	CLRF	TRISB		; piny RB<7:0> jako vstupy

; Nastaven peruen
	BSF		PIE1, TMR1IE	; povolen peruen od asovae TIMER1
	BSF		INTCON, PEIE	; povolen perifernch peruen

; Nastaven internho osciltoru
	MOVLW	b'01110000'	
	MOVWF	OSCCON		; f = 8MHz
	
	BCF		STATUS, RP0	; vbr banky 0

; Nastaven modulu CCP
	MOVLW	b'00001001'	
	MOVWF	CCP1CON		; md compare, nastav rove L pi CCPR1=TMR1

; Nastaven asovae TIMER1
	MOVLW	b'00000001'	
	MOVWF	T1CON		; peddlicka 1:1, hod. signl odvozen od vnitnho instruknho cyklu (Fosc/4), TIMER1 zapnut

	CALL	CLEAR
	BSF		INTCON, GIE		; povolen celho systmu peruen

MAIN
; Ppadn dal kd v hlavn smyce
	GOTO	MAIN

CHANGE_LED
	MOVF	CCPR1L, W
	MOVWF	pwmL		; pwmL = CCPR1L
	MOVF	CCPR1H, W
	MOVWF	pwmH		; pwmH = CCPR1H

	RRF		pwmH, f		; rotace pwmH vpravo, LSB -> C
	RRF		pwmL, f		; rotace pwmL vpravo, C -> MSB
	RRF		pwmH, f		; rotace pwmH vpravo, LSB -> C
	RRF		pwmL, f		; rotace pwmL vpravo, C -> MSB
	MOVLW	b'00111111'
	ANDWF	pwmH, W		; pwmH<7:6> = 00, vsledek -> W

	ADDWF	CCPR1H, f	; CCPR1H = CCPR1H + W (pwmH)
	BTFSC	STATUS, C	; dolo k peteen?
	GOTO	CLEAR		; - ano: vchoz jas a nvrat
	MOVF	pwmL, W		; W = pwmL
	BTFSC	STATUS, Z	; W (pwmL) = 0?
	MOVLW	0x01		;  - ano: W = 1

	ADDWF	CCPR1L, f	; CCPR1L = CCPR1L + W (pwmL nebo 1)
	BTFSS	STATUS, C	; dolo k peteen?
	RETURN				; - ne: nvrat
	INCF	CCPR1H, f	; - ano: CCPR1H = CCPR1H + 1
	BTFSS	STATUS, Z	; dolo k peteen?
	RETURN				; - ne: nvrat
						; - ano: vchoz jas...
CLEAR					; nastav vchoz (nejmen) jas
	MOVLW	0x9
	MOVWF	CCPR1L
	CLRF	CCPR1H
	RETURN

	END