	title "Penos dat mezi dvma mikrokontrolry prostednictvm sbrnice SPI - obvod slave"

; Seril "Mikrokontrolry PIC", dl 53
; PE-AR 05/2012
;
; Vt pringl
;
; Popis: Data penesen pes SPI se zapisuj na port B (piny RB5 a RB7).

	LIST		p=16F88				; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		RXDATA
	ENDC

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1

	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	MOVLW	b'00010010'	
	MOVWF	TRISB		; piny RB4 (SCK) a RB1 (SDI) jako vstupy, ostatn jako vstupy

	MOVLW	b'00000000'	; vchoz nastaven stavovho registru modulu SSP
	MOVWF	SSPSTAT

	BCF		STATUS, RP0	; vbr banky 0

	MOVLW	b'00100101'
	MOVWF	SSPCON		; CKP=0 (v neaktivnm stavu je SCK=L), md slave se zakzanm pinem SS, povolen SSP
	
MAIN
	CALL	SPI
	MOVF	RXDATA, W
	ANDLW	b'11100000'	; maskovn bit
	MOVWF	PORTB		; W -> PORTB
	GOTO	MAIN

SPI
	BSF		STATUS, RP0	; vbr banky 1
SPI_LOOP	
	BTFSS	SSPSTAT, BF	; byla pijata data?
	GOTO	SPI_LOOP	;  -ne: skok na SPI_LOOP
	BCF		STATUS, RP0	;  -ano: vbr banky 0
	MOVF	SSPBUF, W	; SSPBUF -> W
	MOVWF	RXDATA		; uloen pijatch dat do reg. RXDATA

	RETURN

	END