	title "Penos dat mezi dvma mikrokontrolry prostednictvm sbrnice SPI - obvod master s peruenm"

; Seril "Mikrokontrolry PIC", dl 53
; PE-AR 05/2012
;
; Vt pringl
;
; Popis: rovn na pinech RB5 a RB7 se pen pes SPI do dalho mikrokontrolru; s vyuitm peruen pi zmn rovn na portu B.

	LIST		p=16F88				; nastaven typu procesoru
	#INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===
	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
W_temp		EQU	0x70	; doasn uloen obsahu registru W pi vyvoln peruen
status_temp	EQU	0x71	; doasn uloen obsahu registru STATUS pi vyvoln peruen

; === DEFINICE BIT ===
RBPU	EQU	0x7

; === VEKTOR RESETU ===
RESET	ORG		0x0000		; zatek programu na adrese 0000h
		GOTO	INIT

; === OBSLUHA PERUEN ===
ISR		ORG		0x0004		; vektor peruen
; Uloen obsahu registr W a STATUS
	MOVWF	W_temp
	MOVF	STATUS,W		; W -> W_temp
	MOVWF	status_temp		; STATUS -> status_temp

	MOVF	PORTB, W	; PORTB -> W
	ANDLW	b'11100000'	; maskovn bit
	MOVWF	SSPBUF		; W -> SSPBUF: iniciovn penosu

	BSF		STATUS, RP0	; vbr banky 1
SPI_LOOP
	BTFSS	SSPSTAT, BF	; penos dat dokonen?
	GOTO	SPI_LOOP	;  -ne: skok na SPI_LOOP
	BCF		STATUS, RP0	;  -ano: vbr banky 0
	MOVF	SSPBUF, W	; SSPBUF -> W (naten SSPBUF pro vynulovn bitu BF)
	
	BCF		INTCON, RBIF	; vynulovn pznaku peruen pi zmn rovn na portu B

; Nahrn obsahu registr W a STATUS
	MOVF    status_temp, W
	MOVWF   STATUS
	SWAPF   W_temp, f
	SWAPF   W_temp, W
	RETFIE
	
INIT
; Inicializace port
	CLRF	PORTA		; inicializace portu A
	CLRF	PORTB		; inicializace portu B

	BSF		STATUS, RP0	; vbr banky 1

	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny RA<7:0> jako vstupy
	MOVLW	b'11100010'	
	MOVWF	TRISB		; piny RB<7:5> a pin RB1 (SDI) jako vstupy, ostatn jako vstupy

	MOVLW	b'00000000'	; vchoz nastaven stavovho registru modulu SSP
	MOVWF	SSPSTAT		; CKE=0 (penos dat pi zmn rovn hodinovho signlu z neaktivn do aktivn)
						; SMP=0 (vzorkovn vstupnch dat uprosted doby, kdy jsou na vstupu platn data)

	BCF		OPTION_REG, RBPU	; povolen pull-up rezistor na portu B

	BCF		STATUS, RP0	; vbr banky 0

	MOVLW	b'00100000'
	MOVWF	SSPCON		; CKP=0 (v neaktivnm stavu je SCL=L), md master f=fosc/4, povolen SSP
	
	MOVF	PORTB, W
	MOVLW	b'10001000'
	MOVWF	INTCON		; povolen peruen pi zmn rovn na pinech RB7:RB4

MAIN
	SLEEP
	NOP
	GOTO	MAIN
	
	END