	title "Demonstrace zkmit tlatek"

; Seril "Mikrokontrolry PIC", dl 58
; PE-AR 10/2012
;
; Vt pringl
;
; Popis: S kadm stiskem tlatka se posune svtc LED o jednu pozici. Vzhledem k zkmitm 
;		 tlatka se vak me mikrokontrolr jedin stisk vyhodnotit jako vcensobn, a LED 
;		 se pak posune o vce pozic.

     LIST		p=16F88				; nastaven typu procesoru
     #INCLUDE	<P16F88.INC>		; definice promnnch pro tento procesor

; === NASTAVEN KONFIGURANHO SLOVA ===

	__CONFIG	_CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG	_CONFIG2, _IESO_OFF & _FCMEN_OFF

; === DEFINICE PROMNNCH ===
	CBLOCK	0x20
		key_status	; informace o stavu tlatka
		porta_led	; stav LED pipojench k portu A
	ENDC

; === DEFINICE BIT ===
KS0		EQU	0x0			; Oznaen stavovho bitu registru key_status, ve kterm je uloen posledn 
						; stav tlatka TL0. KS0=0 zna, e je tlatko uvolnno, KS0=1 zna, e 
						; je tlatko stisknuto.
RBPU	EQU	0x7

; === PROGRAM ===

RESET	ORG		0x0000		; zatek programu na adrese 0000h

; Inicializace portu
	CLRF	PORTA		; inicializace PORTA
	CLRF	PORTB		; inicializace PORTB

	BSF		STATUS, RP0	; vbr banky 1
	CLRF	ANSEL		; piny AN<6:0> jako digitln I/O
	CLRF	TRISA		; piny portu A jako vstupy
	MOVLW	b'10000000'
	MOVWF	TRISB		; piny RB<6:0> jako vstupy, RB7 jako vstup

	BCF		OPTION_REG, RBPU	; povolen pull-up rezistor na portu B
	
; Inicializace internho osciltoru
	MOVLW	b'01110000'
	MOVWF	OSCCON		; nastaven kmitotu internho osciltoru na 8 MHz
	
	BCF		STATUS, RP0	; vbr banky 0

; Inicializace promnnch
	CLRF	key_status
	MOVLW	b'00000001'
	MOVWF	porta_led	; rozsvi LED0
	CALL	WRITE_LED

; Hlavn smyka programu
MAIN
	; zde me mikrokontrolr vykonvat dal innost
	CALL	SCAN_KEY
	GOTO	MAIN

; Podprogram pro naten stavu tlatka
SCAN_KEY
	BTFSC	key_status, KS0	; KS0 = 0 (posledn stav tlatka = uvolnno)?
	GOTO	SCAN_KEY1		; - ne: skok na SCAN_KEY1
	BTFSC	PORTB, 7		; - ano: je tlatko nyn stisknuto?
	RETURN					; - ne: dn zmna, nvrat
	CALL	CHANGE_LED		; - ano: rotace LED ...
	BSF		key_status, KS0	; ... a nastav stavov bit KS0
	RETURN					; nvrat
SCAN_KEY1
; posledn stav tlatka = stisknuto
	BTFSC	PORTB, 7		; je tlatko nyn stisknuto?
	BCF		key_status, KS0	; - ne, tlatko je uvolnno: vynuluj stav. bit KS0
	RETURN					; - ano: dn zmna, nvrat

; Podprogram pro rotaci LED
CHANGE_LED
	BCF		STATUS, C
	BTFSC	porta_led, 3	; svt-li posledn LED v ad, nastav C=1
	BSF		STATUS, C
	RLF		porta_led, f	; rotace LED
	CALL	WRITE_LED
	RETURN

; Podprogram pro zpis stavu LED na vstupy
WRITE_LED
	MOVLW	b'00001111'
	ANDWF	porta_led, W
	MOVWF	PORTA			; zpis na port A
	RETURN

	END
